<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="xml" indent="yes"/>
    <xsl:template match="/">
        <xsl:apply-templates select="component"/>
    </xsl:template>
    <xsl:template match="component">
        <ul class="menu">
            <!-- Bootstrap to Home page -->
            <li>
                <a href="carbon.welcome.command">Home</a>
            </li>
            <xsl:apply-templates select="general"/>
        </ul>
    </xsl:template>

    <xsl:template match="general">
        <!-- General menus will be applied here-->
        <xsl:apply-templates select="menu"/>
    </xsl:template>

    <xsl:template match="menu">
        <xsl:variable name="action_ref" select="@action-ref"/>
        <xsl:variable name="menu_name" select="@name"/>
        <li>
            <a href="{$action_ref}.command">
                <xsl:value-of select="$menu_name"/>
            </a>
        </li>
    </xsl:template>
</xsl:stylesheet>

