
var showDivHome = true;
var serviceSpecificName;
var SHOW_HOME_REFRESH_TIME = 6000;

var showDivHomeTimeout;
var showHomeInterval = 0;
var serviceDataRefreshInterval = 0;

var SERVER_ADMIN_STRING = "ServiceAdmin"

	function refreshFrame() {

		window.location.href='service_mgt.jsp';
	}

function showHomeMenu() {

    //    renderHomeMenuExplicitly();
    //Initial Firing
    if (showHomeInterval == 0) {
        showHomeInterval = setInterval('listServiceGroups()', SHOW_HOME_REFRESH_TIME);
    }
}

function showError(divId){
	var the_div=document.getElementById(divId);
	if(the_div.style.display==""){
		the_div.style.display="none";
	}
	else{
		the_div.style.display = "";
	}
}

function listServiceGroups() {
    var body_xml = '<ns1:listServiceGroups  xmlns:ns1="http://org.apache.axis2/xsd">\n' +
                   ' </ns1:listServiceGroups>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" + "/" + "listServiceGroups";
    new wso2.wsf.WSRequest(callURL, "listServiceGroups", body_xml, listServiceGroupsCallback);
}

function listServiceGroupsCallback() {
	 var serviceGroups = this.req.responseXML.getElementsByTagName("group_id");
	 var viewTitleHTML = "<h2>Deployed Services</h2>";

     if(serviceGroups.length > 0){
	 	 var tableHTML = '<table id="service_groups_info_table" class="styled"><thead><tr><th>Services</th><th>Actions</th><th>View</th></tr></thead><tbody>';

		 for(var x=0; x<serviceGroups.length; x++){
		   var seviceGroupId = serviceGroups[x].firstChild.nodeValue;

		 	tableHTML = tableHTML + '<tr>' +
		 					 '<td>' +
		 					   '<a onclick="javascript:listServiceData(\''+seviceGroupId+'\',true); return false;" href="#">' + seviceGroupId + '</a>' +
					     	 '</td>' +
							 '<td>' +
								'<nobr>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;' +
									'<a href="#" id="cancel_link" alt="Remove" title="Remove ' + seviceGroupId + ' Service Group" onclick="javascript:deleteServiceGroup(\''+seviceGroupId+'\');return false;">' +
                         '&#160;&#160;&#160;&#160;' +
                         '&#160;&#160;&#160;&#160;' +
                         '&#160;&#160;&#160;&#160;' +
                         '</a>' +
								'</nobr>' +
							'</td>' +
						     '<td>' +
					         '<a target="_blank" href="'+ serverURL +'/'+seviceGroupId+'?wsdl&amp;annotation=false">WSDL 1.1 </a>' +
								'<a target="_blank" href="'+ serverURL +'/'+seviceGroupId+'?wsdl2&amp;annotation=false">WSDL 2.0 </a>' +
								'<a target="_blank" href="'+ serverURL +'/'+seviceGroupId+'?xsd&amp;annotation=false">Schema </a>' +
							 '</td>' +
						  '</tr>';
		 }

	   tableHTML = tableHTML + '</tbody></table>';
      document.getElementById("listServicesInformation").innerHTML = viewTitleHTML + tableHTML;
	 }else{
		document.getElementById("listServicesInformation").innerHTML = '<b>No Active Services</b>';
	 }

    loadFaultyServices();
}

function loadFaultyServices() {
    var body_xml = '<req:getNumberOfFaultyServicesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getNumberOfFaultyServicesRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    new wso2.wsf.WSRequest(callURL, "getNumberOfFaultyServices", body_xml, loadFaultyServicesCallback);
}

function loadFaultyServicesCallback() {

    var obj = document.getElementById('divFaultyServices');

    var data = this.req.responseXML;
    var intValue = data.getElementsByTagName("return")[0].firstChild.nodeValue;

    if (intValue != '0') {
        obj.innerHTML = '<br><b><i><a href="faulty_services.jsp">('+intValue+') Faulty Services</a></i><b>';
    }else{
        obj.innerHTML = '';
    }

}

function transformationWithoutHistory(xmlObj, xslFile, objDiv, params) {
    var xsltHelperObj = new wso2.wsf.XSLTHelper();
    xsltHelperObj.transform(objDiv, xmlObj, xslFile, false, false, params);
    wso2.wsf.Util.showOnlyOneMain(objDiv, true);

}

function listFaultyArchives() {
	generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "FaultyServices");
    var body_xml = '<req:getFaultyServiceArchivesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getFaultyServiceArchivesRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    new wso2.wsf.WSRequest(callURL,"getFaultyServiceArchives",body_xml,listFaultyArchivesCallback);
}

function listFaultyArchivesCallback(){
    var faultyServices = this.req.responseXML.getElementsByTagName("return");

	 if(faultyServices.length > 0){
	 	 var tableHTML = '<table class="styled"><thead><tr><th>Faulty Service</th><th>Action</th></tr></thead><tbody>';

		 for(var x=0; x<faultyServices.length; x++){
		   var servicePath = faultyServices[x].getElementsByTagName("serviceName")[0].firstChild.nodeValue;

			var segments = servicePath.split('/');
		   var serviceName = segments[segments.length-1];

		   var fault = faultyServices[x].getElementsByTagName("fault")[0].firstChild.nodeValue;

		 	tableHTML = tableHTML + '<tr><td>' +
							'<a onclick="showError(\'errorMsg'+(x+1)+'\');" style="cursor: pointer;">'+serviceName+'</a></td>' +
                     '<td>'+
								'<nobr>'+
							  		'<img style="cursor:pointer;" src="../../../../styles/images/cancel.gif" alt="Remove" title="Remove this Service" onclick="javascript:deleteFaultyService(\''+servicePath+'\');return false;" />' +
								'</nobr>'+
							 '</td></tr>'+
								 '<tr style="display: none;" id="errorMsg'+(x+1)+'"><td colspan="2">'+fault+'</td></tr>'+
                      '<tr>';
		 }

	   tableHTML = tableHTML + '</tbody></table>';
      document.getElementById("faultyServices").innerHTML = tableHTML;
	 }else{
		document.getElementById("faultyServices").innerHTML = '<b>No Faulty Services</b>';
	 }

}

function deleteFaultyService(faultServicePath) {
    var delete_to = confirm("Do you really want to Delete this Faulty Service ?");
    if (delete_to == true) {
        var body_xml = '<req:deleteFaultyServiceArchiveRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       ' <req:archiveName>' + faultServicePath + '</req:archiveName>\n' +
                       ' </req:deleteFaultyServiceArchiveRequest>\n';

        var callURL = serverURL + "/" + "ServiceAdmin" ;
        new wso2.wsf.WSRequest(callURL,"deleteFaultyServiceArchive",body_xml,deleteFaultyServiceCallback);
    } else {
        //        alertMessage("Aborted Deletion.")
        return false;
    }

}

function deleteFaultyServiceCallback() {
    wso2.wsf.Util.cursorWait();
    setTimeout("wso2.wsf.Util.alertMessage('The Faulty Service has been successfully deleted')", 1000);
    listFaultyArchives();
}

function deleteServiceGroup(serviceGroupName) {
    var delete_to = confirm("Do you really want to delete [" + serviceGroupName + "] ?");
    if (delete_to) {
        var body_xml = '<req:deleteServiceGroupRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       ' <req:serviceGroupName>' + serviceGroupName + '</req:serviceGroupName>\n' +
                       ' </req:deleteServiceGroupRequest>\n';

        var callURL = serverURL + "/" + "ServiceAdmin" ;
//        new wso2.wsf.WSRequest(callURL, "deleteServiceGroup", body_xml, function() {/*empty function*/});
        new wso2.wsf.WSRequest(callURL, "deleteServiceGroup", body_xml, deleteServiceGroupCallback);
    }
}

function deleteServiceGroupCallback() {
//    wso2.wsf.Util.cursorWait();
//    setTimeout("wso2.wsf.Util.alertMessage('The Service has been successfully deleted')", 1000);
    wso2.wsf.Util.alertMessage('The Service has been successfully deleted');
//    listServiceGroups();
}



function listServiceData(serviceName, notBack, isReschedule) {

    if (notBack) {
        updateHistory("Services", self.location.toString(), "jsp");
    }
    serviceSpecificName = serviceName;

    var body_xml = '<req:getServiceDataRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceName>' + serviceName + '</req:serviceName>\n' +
                   ' </req:getServiceDataRequest>\n';
    var callURL = serverURL + "/" + "ServiceAdmin" + "/" ;
    new wso2.wsf.WSRequest(callURL, "getServiceData", body_xml, listServiceDataCallback);

    // scheduling for periodic refresh
    if(isReschedule){
        clearInterval(serviceDataRefreshInterval);
        serviceDataRefreshInterval = setInterval('listServiceData("' + serviceName + '")', SHOW_HOME_REFRESH_TIME);
    }
}

function listServiceDataCallback() {
    wso2.wsf.Util.callbackhelper(this.req.responseXML, "list_service_main_info.xsl", document.getElementById("divListServiceData"));
    generateBreadcrumbs(document.getElementById("breadcrumbDiv"), serviceSpecificName);
}

function showServiceGroupInfo(groupName) {
    //TODO
}

/**
 * Configure service level MTOM handling
 */
function configServiceMTOM(flag,serviceName) {

    var body_xml = '<req:configureMTOM xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<flag>' + flag + '</flag>\n' +
                   '<serviceName>' + serviceName + '</serviceName>\n' +
                   '</req:configureMTOM>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" + "/" ;

    new wso2.wsf.WSRequest(callURL, "urn:configureMTOM", body_xml, configServiceMTOMCallback);
}

function configServiceMTOMCallback() {

    listServiceData(serviceSpecificName);

}

function activationOfService(serviceStatus) {
    var body_xml = '';
    var callURL = serverURL + "/" + "ServiceAdmin" ;
    if (serviceStatus) {
        body_xml = '<req:startServiceRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceName>' + serviceSpecificName + '</req:serviceName>\n' +
                   ' </req:startServiceRequest>\n';
        new wso2.wsf.WSRequest(callURL, "urn:startService", body_xml, activationOfServiceCallback);
    }
    if (!serviceStatus) {
        body_xml = '<req:stopServiceRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceName>' + serviceSpecificName + '</req:serviceName>\n' +
                   ' </req:stopServiceRequest>\n';
        new wso2.wsf.WSRequest(callURL, "urn:stopService", body_xml, activationOfServiceCallback);
    }
}

function activationOfServiceCallback() {

    wso2.wsf.Util.cursorWait();
    setTimeout("show()", 1000);
}

function showlistServiceData() {
    wso2.wsf.Util.cursorClear();
    listServiceData(serviceSpecificName);
    var obj = document.getElementById("divListServiceData");
    wso2.wsf.Util.showOnlyOneMain(obj);
}

function generateTryitFromService(serviceName) {
    addHistoryForServiceInfo();
//    var wsdlUrl = HTTP_URL + '/' +serviceName + '?wsdl2';
//    var bodyXml = '<req:generateAJAXApp xmlns:req="http://org.wso2.wsf/tools">\n' +
//                      '<url><![CDATA[' + wsdlUrl +']]></url>\n' +
//                      '<hostName><![CDATA['+ HOST+']]></hostName>\n' +
//                      '</req:generateAJAXApp>\n';
//        var callURL = wso2.wsf.Util.getServerURL() + "/" + "GenericAJAXClient" ;
//        wso2.wsf.Util.cursorWait();
//        new wso2.wsf.WSRequest(callURL, "urn:generateAJAXApp", bodyXml, generateTryitFromServiceCallback);

    var bodyXml = '<req:generateAJAXAppForExistingService xmlns:req="http://org.wso2.wsf/tools">\n' +
                      '<serviceName>' + serviceName +'</serviceName>\n' +
                      '</req:generateAJAXAppForExistingService>\n';
        var callURL = wso2.wsf.Util.getServerURL() + "/" + "GenericAJAXClient" ;
        wso2.wsf.Util.cursorWait();
        new wso2.wsf.WSRequest(callURL, "urn:generateAJAXAppForExistingService", bodyXml, generateTryitFromServiceCallback);
}

function generateTryitFromServiceCallback() {
    var data = this.req.responseXML;
    var responseTextValue = data.getElementsByTagName("return")[0].firstChild.nodeValue;
    window.location = GURL + responseTextValue;
//    setTimeout('generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Try Web Service")', 5000);
}

function handleExposedTransports(serviceId) {
    addHistoryForServiceInfo();
    getExposedTransports(serviceId);
}

// following functions is uesed in Services/Exposed Transport section

function getExposedTransports(serviceId) {

    /*stopping the refreshing first */
//    stoppingRefreshingMethodsHook();

    var body_xml = '<req:getExposedTransportsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceId>' + serviceId + '</serviceId>\n' +
                   '</req:getExposedTransportsRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    new wso2.wsf.WSRequest(callURL,"getExposedTransports",body_xml,getExposedTransportsCallback);

}

function getExposedTransportsCallback() {

    //        alert("Response" + (new XMLSerializer()).serializeToString(getBody(xhReq.responseXML)));
    wso2.wsf.Util.callbackhelper(this.req.responseXML,"list_exposed_transports.xsl",
            document.getElementById("divListTransports"));

    // breadcrumbs setting
//    showListTransportDiv(document.getElementById('breadcumbsgetExposedTransportsHeader'));
    clearInterval(serviceDataRefreshInterval); 
    listSystemTransports();
    generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Manage Transports");

}

function listSystemTransports() {

    var body_xml = '<req:listTransportsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '</req:listTransportsRequest>\n';

    var callURL = serverURL + "/" + "TransportAdmin" ;
    new wso2.wsf.WSRequest(callURL,"listTransports",body_xml,listSystemTransportsCallback);

}

function listSystemTransportsCallback() {
    //    alert("Response" + (new XMLSerializer()).serializeToString(getBody(xhReq.responseXML)));

    var txSelectionCombo = document.getElementById('transportSelectionCombo');

    var data = this.req.responseXML;

    var protocols = data.getElementsByTagName('protocol');

    for (var i = 0; i < protocols.length; i++) {
        txSelectionCombo.options[i] = new Option(protocols[i].firstChild.nodeValue);
        txSelectionCombo.options[i].value = protocols[i].firstChild.nodeValue;
    }

}

function addNewTransportForService(obj) {
    //selecting the value from combo
    var protocol = obj[obj.selectedIndex].value;

    var body_xml = '<req:exposeServiceViaTransportRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceId>' + serviceSpecificName + '</serviceId>\n' +
                   '<transportProtocol>' + protocol + '</transportProtocol>\n' +
                   '</req:exposeServiceViaTransportRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    new wso2.wsf.WSRequest(callURL,"addTransportBinding",body_xml,addNewTransportForServiceCallback);
}

function addNewTransportForServiceCallback() {

    wso2.wsf.Util.showResponseMessage(this.req.responseXML);
    getExposedTransports(serviceSpecificName);
}

function removeTransportBinding(protocol) {

    var conf = confirm("Do you want to remove the " + protocol +
                       " transport binding for this service?");
    if (!conf) {
        return true;
    }
    var body_xml = '<req:removeTransportBindingRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceId>' + serviceSpecificName + '</serviceId>\n' +
                   '<transportProtocol>' + protocol + '</transportProtocol>\n' +
                   '</req:removeTransportBindingRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    new wso2.wsf.WSRequest(callURL,"removeTransportBinding",body_xml,removeTransportBindingCallback);
}

function removeTransportBindingCallback() {

    wso2.wsf.Util.showResponseMessage(this.req.responseXML);
    getExposedTransports(serviceSpecificName);
}

function addHistoryForServiceInfo() {
    updateHistory(serviceSpecificName, self.location.toString(), "xslt", "listServiceData('" + serviceSpecificName + "')");
}
