<%@ page language="java" contentType="text/html; charset=ISO-8859-1"
    pageEncoding="ISO-8859-1"%>

<%@ page import="org.wso2.carbon.service.mgt.server.*" %> 
<%@ page import="org.wso2.carbon.service.mgt.xsd.ServiceGroupMetaData" %>
<%@ page import="org.wso2.carbon.service.mgt.ui.*" %>

<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.osgi.framework.BundleContext" %>
<%@ page import="org.osgi.framework.ServiceReference" %>
<%@ page import="org.wso2.carbon.service.mgt.admin.ServiceAdminStub" %>
<%@ page import="org.wso2.carbon.service.mgt.xsd.ServiceGroupMetaData" %>
<%@ page import="org.wso2.carbon.service.mgt.xsd.FaultService" %>
<%@ page import="org.wso2.carbon.core.ServerManager" %>
<%@ page import="org.wso2.carbon.registry.service.RegistryService" %>
<%@ page import="org.wso2.registry.Registry"%>
<%@ page import="org.wso2.registry.Resource" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <link href="../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="global-params.js"></script>
    <script language="javascript" src="../main/admin/js/main.js"></script>
    <script language="javascript" src="../main/admin/js/dhtmlHistory.js"></script>
    <script language="javascript" src="../main/admin/js/WSRequest.js"></script>
    <script language="javascript" src="../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../main/admin/js/cookies.js"></script>
    <script language="javascript" src="extensions/core/js/services.js"></script>
    <title>WSO2 Carbon - Faulty Services</title>
</head>

<script language="JavaScript">
        function init() {
            // intialize the code and call to the back end
            wso2.wsf.Util.initURLs();
            /*Initialize the XSLT cache*/
            wso2.wsf.XSLTHelper.init();                                
            generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "FaultyServices");
        }

</script>
<body onload="init()">
  
<div id="middle">
	 
    <div id="breadcrumbDiv" style="display:none;"></div>
	<h2>Faulty Services</h2>
    	<div id="faultyServices">		  
 							   <%  
		                          FaultService[] data = null;
 							      String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
		                          try {
		                        	  ServiceListing service = new ServiceListing();   
		        			    	 data = service.getAllFaultyServices(cookie);
		        				  } catch (Exception e) {
		            				 e.printStackTrace();
 		        				  }
		        				  if (data != null) {
		        				%>

           
            <br> 
            
              <table class="styled">
                <thead>
				  <tr>
                     <th>Faulty Service</th>
                     <th>Action</th>
                  </tr>
                </thead>
            <tbody>
                    <%
                    int count= 0;
                         for(FaultService datas :data)
                         {
                        	 if(datas != null)
                        	 {
                        	
                        	 count++;	 
                        	 %>
                                 <tr><td>
                                     <%
                                          String faultyServiceName = datas.getServiceName().substring(datas.getServiceName().lastIndexOf('/')+1,datas.getServiceName().lastIndexOf('.'));
                                     %>
									 <a style="cursor:pointer" onclick="showError('errorMsg<%=count%>');"><%=faultyServiceName%></a></td>
                        		     <td>
										<nobr>
                                        	&#160;&#160;
                                        	&#160;&#160;
									  		<a href="#" onclick="javascript:deleteFaultyService('<%=datas.getServiceName()%>');return false;" id="cancel_link" title="Remove Service" alt="Remove">
											&#160;&#160;&#160;&#160;
									  		</a>
                                            <a href="<%="../ds/edit_xml.jsp?serviceName="+faultyServiceName%>" id="edit_link" title="Edit Faulty Service" alt="Edit">
                                          &#160;&#160;&#160;&#160;
                                          &#160;&#160;&#160;&#160;
                                            </a>                                            
										</nobr>
										
								  	 </td>
		                       	 </tr>
								 <tr id="errorMsg<%=count %>" style="display:none"><td colspan="2"><%=datas.getFault()%></td></tr>
                        	<%
                              }
                         }
		        				}
                    %>   
    </div>
<div id="divListServiceData" style="display:none;"></div>    
      
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>