<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.KeyStoreAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.keystore.xsd.KeyStoreData" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/main.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js" type="text/javascript"></script>
    <title>WSO2 Carbon - Security Configuration</title>
</head>

<%
    String haveToDelete = "false";
    Object o = session.getAttribute("keystore-added");
    if (o != null && o.equals("true")) {
        haveToDelete = "true";
        session.removeAttribute("keystore-added");
    }
%>

<script language="JavaScript">

    function setBreadcrumb() {
        var temp = "<%= haveToDelete%>";
        if (temp == "true") {
            goBack(2);
        }
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Keystores");
    }

    function addToHistory() {
        updateHistory("Keystores", self.location.toString(), "jsp");
    }

    function deleteKeystore(keystore) {
        var reply = confirm('Do you want to delete the keystore ' + keystore);
        if (reply) {
            location.href = 'delete-keystore.jsp?keyStore=' + keystore;
        }
    }
</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>Keystore Management</h2>

    <div id="formset">
        <form>
    <fieldset>
        <p>
            <legend>Available Keystores</legend>
        </p>

        <%
            KeyStoreData[] datas = null;
            try {
                String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
                KeyStoreAdminClient client = new KeyStoreAdminClient(cookie);
                datas = client.getKeyStores();
            } catch (Exception e) {
                e.printStackTrace();
            }

            if (datas != null) {
        %>

        <table class="styled">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Type</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <%
                    for (KeyStoreData data : datas) {
                        if (data != null) { //Confusing!!. Sometimes a null object comes. Maybe a bug in Axis!!
                %>
                <tr>
                    <td><%=data.getKeyStoreName()%>
                    </td>
                    <td><%=data.getKeyStoreType()%>
                    </td>
                    <td>
                        <a href="import-cert.jsp?keyStore=<%=data.getKeyStoreName()%>" onclick="addToHistory();">
                            <img src="../extensions/core/images/import.gif" alt="Import Certificate" title="Import Certificate" border="0" /></a>
                        <a href="view-keystore.jsp?keyStore=<%=data.getKeyStoreName()%>" onclick="addToHistory();">
                            <img src="../extensions/core/images/view.gif" alt="View KeyStore" title="View KeyStore" border="0" /></a>
                        <a href="#"
                           onclick="deleteKeystore('<%=data.getKeyStoreName()%>')">
                            <img src="../extensions/core/images/cancel.gif" alt="Delete" title="Delete" border="0" /></a>
                    </td>
                </tr>
                <% }
                }
                %>
            </tbody>
        </table>
        <%
            }
        %>
    </fieldset>
            </form>
        </div>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td class="addNewSecurity"><a href="add-keystore-step1.jsp" onclick="addToHistory();"><img src="../extensions/core/images/add.gif" border="0" /></a></td>
			<td class="addNewSecurity" width="100%"><a href="add-keystore-step1.jsp" onclick="addToHistory();">Add New Keystore</a></td>
		</tr>
	</table>
</div>
</body>
</html>