<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" 
"http://www.w3.org/TR/html4/strict.dtd">
<%@page import="org.wso2.carbon.security.ui.client.SecurityAdminClient"%>
<%@page
	import="org.wso2.carbon.security.ui.config.xsd.SecurityScenarioData"%>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
<script language="javascript" src="../extensions/core/js/vui.js"></script>
<script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
<script language="javascript" src="../../main/admin/js/main.js" type="text/javascript"></script>
<script language="javascript" src="../../main/admin/js/cookies.js"></script>

<title>WSO2 Carbon - Security Configuration</title>
<script language="JavaScript">


function doValidation(){
    var isChecked = false;
    isChecked = isAtleastOneChecked("scenarioId");
    if(isChecked != true){
        wso2.wsf.Util.alertWarning("Please select at leaset one security scenario.");
    }
    return isChecked;
}


function showOptions(){
    var temp = document.getElementById("securityConfiguration");
    if (document.getElementById("securityConfigAction").value == "Yes") {
        temp.style.display = "inline";
    } else if (document.getElementById("securityConfigAction").value == "No") {
        var answer = confirm("This will disable security from the " +
                             "service. Click OK to confirm");
        if (answer) {
            document.deleteSecurity.submit();
        } else {
            document.getElementById("securityConfigAction").value = "Yes";
            temp.style.display = "inline";
        }
    }
} 
    
function setBreadcrumb() {
    generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Security");
}

function addToHistory() {
    updateHistory("Security", self.location.toString(), "jsp");
}
</script>
</head>
<body onload="setBreadcrumb();">
<div id="middle">
<jsp:include page="../display-messages.jsp"/>
<div id="breadcrumbDiv" style="display: none;"></div>
<h2>Security for the service</h2>
<%!String info=null; SecurityScenarioData[] basics =null;SecurityScenarioData[] advanced = null;%> 
<%!String showOption=null;String displalyStyle=null;String[] options=null;%>
<%!SecurityScenarioData currentScenrio = null;%>
<%
String serviceName = null;
serviceName = request.getParameter("serviceName");
if(serviceName!=null){
    serviceName = serviceName.trim();
    if(serviceName.length()>0){
        session.setAttribute("serviceName", serviceName);
    }
}else{
    serviceName = (String)session.getAttribute("serviceName");
}

if(serviceName == null){
    %> <strong>Cannot proceed. Please select a service to enable security!</strong> <%
}else{
    //get current scenario
try{
    String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    SecurityAdminClient client = new SecurityAdminClient(cookie);
    currentScenrio = client.getCurrentScenario(serviceName);

    if(currentScenrio == null){
          info = "The service \""+serviceName+"\" is not secured.";
          options = new String[]{"No", "Yes"};
          displalyStyle="display: none;";
    }else{
        info = "The service \""+serviceName+"\" is secured using \""+currentScenrio.getSummary()+"\"";
        options = new String[]{"Yes", "No"};
        displalyStyle="display: inline;";
    }
    
    basics = client.getBasicScenarios();
    advanced = client.getAdvancedScenarios();
}catch(Exception e){
    e.printStackTrace();
}
%>

<p><strong><%=info%></strong>
</p>
<p></p>
<p></p>
<div id="formset">
<table>
		  <tr>
              <td>Enable Security?</td>
		      <td>
		          <select onchange="showOptions();" id="securityConfigAction" name="enable">
		             <%
                         for (String option : options) {
                     %>
                      <option value="<%=option%>"><%=option%>
                      </option>
                      <%
                          }
			         %>
		          </select>
		      </td>
          </tr>
</table>
<p></p>
<div id="securityConfiguration" style="<%=displalyStyle%>">
<form id="secConfigForm" name="securityForm" method="post" action="ut-ks-advance.jsp" onsubmit="return doValidation();">
<fieldset>
<legend>Security Scenarios</legend>
<p>&nbsp;</p>
<table  class="styled">
<tr>
<td colspan="3">
<Strong>Basic Scenarios</Strong></td></tr>
    <thead>
        <tr>
            <th></th>
            <th>Security Scenario</th>
            <th>Description</th>
        </tr>
     </thead>
     <tbody>
	<%
for(int i=0; i<basics.length ;i++){
    SecurityScenarioData temp = basics[i];
    String secid = temp.getScenarioId();
    %>
	<tr>
	    <td>
	       <%
	       if(currentScenrio!= null && currentScenrio.getScenarioId().equals(secid)){
	           %><input type="radio" name="scenarioId" value="<%=secid%>" checked="checked"/><%
           }else{
	           %><input type="radio" name="scenarioId" value="<%=secid%>"/><%
	       } 
	       %>
	    </td>
		<td>
		<%
        if(secid.equals("scenario1")){%>UsernameToken<%
        }else if(secid.equals("scenario2")){%>Non-repudiation<%
        }else if(secid.equals("scenario4")){%>Integrity<%
        }else if(secid.equals("scenario5")){%>Confidentiality<%
        }
        %>
		</td>
		<td><%=temp.getDescription()%></td>
	</tr>
	<%
}
%>
<tr>
<td colspan="3">
<Strong>Advanced Scenarios</Strong></td></tr>
        <%
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            SecurityAdminClient client = new SecurityAdminClient(cookie);
            SecurityScenarioData[] all = client.getAdvancedScenarios();
            for (int i = 0; i < all.length; i++) {
                SecurityScenarioData scene = all[i];
                String scenarioId = scene.getScenarioId();
                String category = new String(scene.getCategory());
        %>
        <tr>
            <td>
           <%
             if(currentScenrio!= null && currentScenrio.getScenarioId().equals(scenarioId)){
                %><input type="radio" name="scenarioId" value="<%=scenarioId%>" checked="checked"/><%
           }else{
           %><input type="radio" name="scenarioId" value="<%=scenarioId%>"/><%
           }
           %>
           </td>
            <td><%=scene.getSummary()%></td>
            <td><%=scene.getDescription()%></td>
        </tr>
        <%
            }
        %>
        </tbody>
</table>
<input type="submit" value="Next >" onclick="addToHistory();"/>
</fieldset>
</form>
</div>
<%
}
%>
</div>
</div>

<div id="divDeleteSecurity" style="display: none">
    <form name="deleteSecurity" action="remove-security.jsp">
        <input type="submit" value="delete"/>
    </form>
</div>
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
<p>&nbsp;</p>
<p>&nbsp;</p>
</body>
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</html>