<%@ page import="org.wso2.carbon.rm.service.MercuryAdminServiceStub"%>
<%@ page import="org.wso2.carbon.rm.service.xsd.MercuryParameterBean"%>
<%@ page import="org.wso2.registry.Registry"%>
<%@ page import="org.wso2.registry.Resource"%>
<%@ page import="org.wso2.carbon.registry.service.RegistryService"%>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.ConfigurationContextFactory" %>
<%@ page import="org.apache.axis2.client.Options" %>
<%@ page import="org.apache.axis2.client.ServiceClient" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
    <link href="../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
<title>Untitled Document</title>
</head>

<body>
<%
    String serviceName = request.getParameter("serviceName");
    RegistryService registryService = (RegistryService) config.getServletContext().getAttribute("registry");
    Registry systemRegistry = registryService.getSystemRegistry();
    Resource resource = systemRegistry.get("/carbon/connection/props");
    String servicePath = resource.getProperty("service-path");
    String contextRoot = resource.getProperty("context-root");
    contextRoot = contextRoot.equals("/") ? "" : contextRoot;

    ConfigurationContext cc = ConfigurationContextFactory.createConfigurationContextFromFileSystem(null, null);

    String httpPort = System.getProperty("carbon.https.port");
    String url = "https://localhost:" + httpPort + "/" + contextRoot
            + servicePath + "/MercuryAdminService.MercuryAdminServiceHttpsSoap12Endpoint";

    MercuryAdminServiceStub stub = new MercuryAdminServiceStub(cc, url);
    
    String cookie = (String)session.getAttribute(org.wso2.carbon.utils.ServerConstants.ADMIN_SERVICE_COOKIE);
    ServiceClient client = stub._getServiceClient();
    Options option = client.getOptions();
    option.setManageSession(true);
    option.setProperty(org.apache.axis2.transport.http.HTTPConstants.COOKIE_STRING, cookie);

    long rmsSequenceTimeout = Long.parseLong(request.getParameter("rmsSequenceTimeout"));
    long rmsSequenceRetransmitTime = Long.parseLong(request.getParameter("rmsSequenceRetransmitTime"));
    long rmsSequenceWorkerSleepTime = Long.parseLong(request.getParameter("rmsSequenceWorkerSleepTime"));
    long rmsMaximumRetransmitCount = Long.parseLong(request.getParameter("rmsMaximumRetransmitCount"));

    long rmdSequenceTimeout = Long.parseLong(request.getParameter("rmdSequenceTimeout"));
    long rmdSequenceRetransmitTime = Long.parseLong(request.getParameter("rmdSequenceRetransmitTime"));
    long rmdSequenceWorkerSleepTime = Long.parseLong(request.getParameter("rmdSequenceWorkerSleepTime"));

    long invokerTimeout = Long.parseLong(request.getParameter("invokerTimeout"));
    long invokerWorkerSleepTime = Long.parseLong(request.getParameter("invokerWorkerSleepTime"));

    boolean enforceRM = Boolean.parseBoolean(request.getParameter("enforceRM"));
    boolean isRMEngaged = Boolean.parseBoolean(request.getParameter("isRMEngaged"));

    MercuryParameterBean mercuryParameterBean = new MercuryParameterBean();
    mercuryParameterBean.setRmsSequenceTimeout(rmsSequenceTimeout);
    mercuryParameterBean.setRmsSequenceRetransmitTime(rmsSequenceRetransmitTime);
    mercuryParameterBean.setRmsSequenceWorkerSleepTime(rmsSequenceWorkerSleepTime);
    mercuryParameterBean.setRmsMaximumRetransmitCount(rmsMaximumRetransmitCount);

    mercuryParameterBean.setRmdSequenceTimeout(rmdSequenceTimeout);
    mercuryParameterBean.setRmdSequenceRetransmitTime(rmdSequenceRetransmitTime);
    mercuryParameterBean.setRmdSequenceWorkerSleepTime(rmdSequenceWorkerSleepTime);

    mercuryParameterBean.setInvokerTimeout(invokerTimeout);
    mercuryParameterBean.setInvokerWorkerSleepTime(invokerWorkerSleepTime);

    mercuryParameterBean.setEnforceRM(enforceRM);

    if (isRMEngaged){
        stub.enableRM(serviceName);
    } else {
        stub.disableRM(serviceName);
    }

    stub.setParameters(serviceName, mercuryParameterBean);

    request.getRequestDispatcher("/index.jsp").forward(request,response);
%>
</body>
</html>
