<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.userstore.xsd.StoreData" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <title>WSO2 Carbon - Security Configuration</title></head>

<script language="JavaScript">
    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Add-Step1");
    }

    function addToHistory() {
        updateHistory("Add-Step1", self.location.toString(), "jsp");
    }

    function doCancel() {
        goBack(1);
        location.href = 'usergroup-mgt.jsp';
    }
</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>Add New User Group</h2>

    <%
        StoreData[] datas = null;
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserStoreAdminClient client = new UserStoreAdminClient(cookie);
            datas = client.getAllUserStoreNames();
        } catch (Exception e) {
            e.printStackTrace();
        }
    %>
    <div id="formset">
        <form method="get" action="add-usergroup-step2.jsp">
    <fieldset>
        <p>
            <legend>Step 1: Select User Store</legend>
        </p>
                <table>
                    <tr>
                        <td>User store</td>
                        <td>
                            <select name="storeName">
                                <%
                                    if (datas != null) {
                                        for (StoreData data : datas) {
                                            if (data != null) {
                                %>
                                <option value="<%=data.getDisplayName()%>"><%=data.getDisplayName()%>
                                </option>
                                <%
                                            }
                                        }
                                    }
                                %>
                            </select>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="2">&nbsp;</td>
                    </tr>
                    <tr>
                        <td>&nbsp;</td>
                        <td>
                            <input type="submit" value="Next >" onclick="addToHistory();"/>
                            <input type="button" value="Cancel" onclick="doCancel();"/>
                        </td>
                    </tr>
                </table>
    </fieldset>
            </form>
        </div>
</div>
</body>
</html>