<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@page session="true" %>
<%@page import="org.wso2.carbon.security.ui.client.UserGroupAdminClient" %>
<%@page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@page import="java.util.List" %>
<%@page import="java.util.Arrays" %>
<%@page import="org.wso2.carbon.security.ui.userstore.xsd.UserListData"%>
<%@page import="org.wso2.carbon.security.ui.usergroup.xsd.UserGroupData"%>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html>
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../extensions/core/js/vui.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/main.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <title>WSO2 Carbon - Security Configuration</title>
    <script language="JavaScript">
        function doValidation() {
            var isChecked = false;
            isChecked = isAtleastOneCheckedIfExisting("userList");
            if (isChecked != true) {
                wso2.wsf.Util.alertWarning("Please select at leaset one user");
                return false;
            }
            isChecked = isAtleastOneCheckedIfExisting("selectAll");
            if (isChecked != true) {
                wso2.wsf.Util.alertWarning("Please select all users");
                return false;
            }
            return true;
        }

        function setBreadcrumb() {
            generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Edit User Group");
        }
    </script>
</head>
<body onload="setBreadcrumb();">
<div id="middle">
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>Edit User Group</h2>
     <%!UserListData userList =null; %>
     <%!UserGroupData data = null; %>
    <%
        String group = request.getParameter("userGroup");
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserGroupAdminClient client = new UserGroupAdminClient(cookie);
            data = client.getUserGroup(group);

            UserStoreAdminClient storeClient = new UserStoreAdminClient(cookie);
            userList = storeClient.getStoreUsers(data.getStoreName());
        }catch(Exception e){
            e.printStackTrace();
        }    
    %>
    <div id="formset">
    <fieldset>
        <p>
            <legend>User Group Information</legend>
        </p>
    <form method="post" action="edit-usergroup-finish.jsp?groupName=<%=data.getName()%>" onsubmit="return doValidation();">
        <table>
            <tr>
                <td>Name</td>
                <td><input type="text" name="groupName" value="<%=data.getName()%>" readonly="readonly" disabled="disabled"/>
                </td>
            </tr>
            <tr>
                <td>StoreName</td>
                <td><input type="text" name="storeName" value="<%=data.getStoreName()%>" readonly="readonly" disabled="disabled"/>
                </td>
            </tr>
            <tr>
                <td>Description</td>
                <td><input type="text" name="description" value="<%=data.getDescription()%>"/>
                </td>
            </tr>
            <tr>
                <td>Users</td>
                <td>
                
                  <table>
                       <tbody>
                             <%
                                if(userList == null){
                             %>
                                <tr>
                                    <td>
                                        The user list is null. An error occurred while retrieving the user list from the store.
                                    </td>
                                </tr>    
                                <%
                                }else if(userList.getCriteriaOnly()){
                                %>
                                    <tr>
                                        <td>
                                            <p>Too many users to list. Please select a criteria</p>
                                            <p><input type="checkbox" name="selectAll" checked="checked"/>Select All</p>
                                        </td>
                                    </tr>    
                                <%    
                                }else{
                                    String[] values = data.getUsers();
                                    List<String> list = Arrays.asList(values);
                                    String[] names = userList.getUserList();
                                    if (names != null) {
                                        for (String name : names) {
                                            if (name != null) {
                                                String docheck = "";
                                                if (list.contains(name)) {
                                                    docheck = "checked=\"checked\"";
                                                }
                                %>
                                <tr>
                                    <td>
                                     <p><input type="checkbox" name="userList" value="<%=name%>" <%=docheck%>/><%=name%>
                                    </td>
                                </tr>
                                <%
                                            }
                                        }
                                    }
                                }
                                %>
                                </tbody>
                            </table>                                              
                </td>
            </tr>
            <tr>
                <td colspan="2">&nbsp;</td>
            </tr>
            <tr>
                <td>&nbsp;</td>
                <td>
                    <input type="submit" value="Update"/>
                    <input type="button" value="Cancel" onclick="history.back()"/>
                </td>
            </tr>
        </table>
    </form>
    </fieldset>
        </div>
</div>
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>
