<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserGroupAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.usergroup.xsd.UserGroupData" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <script language="javascript" src="../../main/admin/js/main.js"></script>
    <title>WSO2 Carbon - Security Configuration</title></head>

<%
    String haveToDelete = "false";
    Object o = session.getAttribute("usergroup-added");
    if (o != null && o.equals("true")) {
        haveToDelete = "true";
        session.removeAttribute("usergroup-added");
    }
%>

<script language="JavaScript">

    function setBreadcrumb() {
        var temp = "<%= haveToDelete%>";
        if (temp == "true") {
            goBack(2);
        }
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "User Groups");
    }

    function addToHistory() {
        updateHistory("User Groups", self.location.toString(), "jsp");
    }

    function deleteUserGroup(group) {
        var reply = confirm('Do you want to delete the user group ' + group + '?');
        if (reply) {
            location.href = 'delete-usergroup.jsp?userGroup=' + group;
        }
    }
</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>User Groups</h2>
    <div id="formset">
        <form>
    <fieldset>
        <p>
            <legend>Available User Groups</legend>
        </p>
        <table class="styled">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Description</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <%
                    UserGroupData[] groupData = null;
                    try {
                        String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
                        UserGroupAdminClient client = new UserGroupAdminClient(cookie);
                        groupData = client.getUserGroups();
                        if (groupData != null) {
                            for (UserGroupData data : groupData) {
                                if (data != null) { //Confusing!!. Sometimes a null object comes. Maybe a bug in Axis!!
                %>
                <tr>
                    <td><%=data.getName()%>
                    </td>
                    <td><%=data.getDescription()%>
                    </td>
                    <td>
                        <a href="view-usergroup.jsp?userGroup=<%=data.getName()%>" onclick="addToHistory();">
                            <img src="../extensions/core/images/view.gif" alt="View" title="View" border="0" /></a>
                        <a href="edit-usergroup.jsp?userGroup=<%=data.getName()%>" onclick="addToHistory();">
                            <img src="../extensions/core/images/application_edit.gif" alt="Edit" title="Edit" border="0" /></a>
                        <a href="#" onclick="deleteUserGroup('<%=data.getName()%>')">
                            <img src="../extensions/core/images/cancel.gif" alt="Delete" title="Delete" border="0" /></a>
                    </td>
                </tr>
                <%
                            }
                        }
                    }
                } catch (Exception e) {
                %>
                <strong>An error occurred!</strong>

                <p>Error message is : <%=e.getMessage()%>
                </p>
                <%
                    }
                %>
            </tbody>
        </table>
    </fieldset>
            </form>
        </div>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td class="addNewSecurity"><a href="add-usergroup-step1.jsp" onclick="addToHistory();"><img src="../extensions/core/images/add.gif" border="0" /></a></td>
			<td class="addNewSecurity" width="100%"><a href="add-usergroup-step1.jsp" onclick="addToHistory();">Add New User Group</a></td>
		</tr>
	</table>
</div>
</body>
</html>
