<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserGroupAdminClient" %>
<%@page import="org.wso2.carbon.security.ui.usergroup.xsd.UserGroupData"%>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <title>WSO2 Carbon - Security Configuration</title>
</head>

<script language="JavaScript">

    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "View User Group");
    }

</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <%
        String group = request.getParameter("userGroup");
    %>
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>View User Group</h2>
    <%
        UserGroupData details = null;
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserGroupAdminClient client = new UserGroupAdminClient(cookie);
            details = client.getUserGroup(group);
        } catch (Exception e) {
            e.printStackTrace();
        }

        if (details != null) {
    %>
    <div id="formset">
        <form>
    <fieldset>
        <p>
            <legend>Details of User Group <%=group%>
            </legend>
        </p>
        <table>
            <tr>
                <td><strong>Name</strong></td>
                <td><%=details.getName()%>
                </td>
            </tr>
            <tr>
                <td><strong>Description</strong></td>
                <td><%=details.getDescription()%>
                </td>
            </tr>
            <tr>
                <td><strong>User Store</strong></td>
                <td><%=details.getStoreName()%>
                </td>
            </tr>
            <tr>
                <td><strong>Users</strong></td>
                <td><ol style="padding-left: 4px;*padding-left: 10px;">
                        <%
                            if (details.getUsers() != null) {
                                String[] users = details.getUsers();
                                for (String user : users) {
                                    if (user != null) { // prevent null objects returned
                        %>
                        <li>
                            <%=user%>
                        </li>
                        <%
                                    } 
                                }
                            }
                        }
                        %>
                    </ol>
                </td>
            </tr>
        </table>
    </fieldset>
  </form>
</div>
</div>
</body>
</html>
