<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../extensions/core/js/vui.js"></script>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <script language="javascript" src="../../main/admin/js/main.js"></script>
    <title>WSO2 Carbon - Security Configuration</title>
    <script language="JavaScript">
        function doValidation() {
            var reason = "";
            reason = validateEmpty("username");
            if (reason != "") {
                wso2.wsf.Util.alertWarning('Enter a valid : User Name');
                return false;
            }
            
            reason = validateName("username");
            if (reason != "") {
                wso2.wsf.Util.alertWarning("Spaces are not allowed in : User Name");
                return false;
            }
            
            reason = validatePassword("password", "retype");
            if (reason != "") {
                wso2.wsf.Util.alertWarning(reason);
                return false;
            }
            return true;
        }

        function setBreadcrumb() {
            generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Add");
        }
    </script>
</head>
<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>

    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>Add User</h2>
    <div id="formset">
        <form method="get" action="add-user-finish.jsp" name="dataForm" onsubmit="return doValidation();">
    <fieldset>

            <table>
                <tr>
                    <td>User Name<font color="red">*</font></td>
                    <td><input type="text" name="username"/></td>
                </tr>
                <tr>
                    <td>Role Name<font color="red">*</font></td>
                    <td>
                        <select name="roleName">
                            <option value="admin">Admin User</option>
                            <option value="user">General User</option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td>Password<font color="red">*</font></td>
                    <td><input type="password" name="password"/></td>
                </tr>
                <tr>
                    <td>Password Repeat<font color="red">*</font></td>
                    <td><input type="password" name="retype"/></td>
                </tr>
                <tr>
                    <td colspan="2">&nbsp;</td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td>
                        <input type="submit" value="Finish"/>&nbsp;&nbsp;
                        <input type="button" value="Cancel" onclick="location.href = 'user-mgt.jsp'"/>
                    </td>
                </tr>
            </table>

    </fieldset>
            </form>
        </div>
    <p>&nbsp;</p>
</div>
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>