<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.userstore.xsd.UserData" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <script language="javascript" src="../../main/admin/js/main.js"></script>
    <title>WSO2 Carbon - Security Configuration</title></head>

<%
    String haveToDelete = "false";
    Object o = session.getAttribute("user-added");
    if (o != null && o.equals("true")) {
        haveToDelete = "true";
        session.removeAttribute("user-added");
    }
%>

<script language="JavaScript">

    function setBreadcrumb() {
        var temp = "<%= haveToDelete%>";
        if (temp == "true") {
            goBack(1);
        }
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Users");
    }

    function addToHistory() {
        updateHistory("Users", self.location.toString(), "jsp");
    }

    function deleteUser(user) {
        if (user == '<%= request.getSession().getAttribute("logged-user")%>') {
            wso2.wsf.Util.alertWarning('You are logged in as ' + user + '. Can\'t delete user');
        } else {
            var reply = confirm('Do you want to delete the user ' + user + '?');
            if (reply) {
                location.href = 'delete-user.jsp?username=' + user;
            }
        }
    }
</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>Users</h2>
    <%
        UserData[] datas = null;
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserStoreAdminClient client = new UserStoreAdminClient(cookie);
            datas = client.getInternalUsers();
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (datas != null) {

    %>
    <div id="formset">
        <form>
    <fieldset>
        <p>
            <legend>Available Users</legend>
        </p>
        <table class="styled">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Type</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <%
                    for (UserData data : datas) {
                        if (data != null) { //Confusing!!. Sometimes a null object comes. Maybe a bug Axis!!
                %>
                <tr>
                    <td><%=data.getUserName()%>
                    </td>
                    <td><%=data.getRoleName()%>
                    </td>
                    <td>
                        <a href="change-passwd.jsp?username=<%=data.getUserName()%>" onclick="addToHistory();">
                            <img src="../extensions/core/images/application_edit.gif" alt="Change Password" title="Change Password" border="0" /></a>
                        <a href="#" onclick="deleteUser('<%=data.getUserName()%>')">
                            <img src="../extensions/core/images/cancel.gif" alt="Delete" title="Delete" border="0" /></a>
                    </td>
                </tr>
                <%
                        }
                    }
                %>
            </tbody>
        </table>
    </fieldset>
            </form>
        </div>
    <%
        }
    %>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td class="addNewSecurity"><a href="add-user.jsp" onclick="addToHistory();"><img src="../extensions/core/images/add.gif" border="0" /></a></td>
			<td class="addNewSecurity" width="100%"><a href="add-user.jsp" onclick="addToHistory();">Add New User</a></td>
		</tr>
	</table>
</div>
</body>
</html>
