<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.userstore.xsd.StoreProperty" %>
<%@ page import="java.util.Map" %>
<%@ page import="java.util.Iterator" %>
<%
    String storeName = null;
    String storeDescription = null;
    String storeType = null;
    try {
        Map paramMap = request.getParameterMap();
        if (paramMap != null && paramMap.size() > 3) {
            StoreProperty[] props = new StoreProperty[paramMap.size() - 3];
            Iterator ite = paramMap.entrySet().iterator();
            int i = 0;
            while (ite.hasNext()) {
                Map.Entry entry = (Map.Entry) ite.next();
                String key = (String) entry.getKey();
                String value = (String) request.getParameter(key);
                if (key.equals("storeName")) {
                    storeName = value;
                } else if (key.equals("storeDescription")) {
                    storeDescription = value;
                } else if (key.equals("storeType")) {
                    storeType = value;
                } else {
                    props[i] = new StoreProperty();
                    props[i].setName(key);
                    props[i].setValue(value);
                    i++;
                }
            }
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserStoreAdminClient client = new UserStoreAdminClient(cookie);
            client.addUserStore(storeName, storeType, storeDescription, props);
            response.sendRedirect("userstore-mgt.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                                  "&message=User store " + storeName + " successfully added");
            session.setAttribute("userstore-added", "true");
        }
    } catch (Exception e) {
        e.printStackTrace();
        response.sendRedirect("add-userstore-step2.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                              "&errorMessage=Cannot add user store " + storeName + ". " +
                              e.getMessage());
    }
%>