<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <script language="javascript" src="../../main/admin/js/main.js"></script>
    <title>WSO2 Carbon - Security Configuration</title></head>

<script language="JavaScript">
    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Add-step1");
    }

    function addToHistory() {
        updateHistory("Add-step1", self.location.toString(), "jsp");
    }

    function doCancel() {
        goBack(1);
        location.href = 'userstore-mgt.jsp';
    }

</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>Add New User Store</h2>

    <%
        String[] types = null;
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserStoreAdminClient client = new UserStoreAdminClient(cookie);
            types = client.getAllUserStoreTypes();
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (types != null) {
    %>
    <div id="formset">
        <form method="post" action="add-userstore-step2.jsp">
    <fieldset>
        <p>
            <legend>Step 1: Select User Store Type</legend>
        </p>

            <table>
                <tr>
                    <td>User Store Type</td>
                    <td>
                        <select name="storeType">
                            <%
                                for (String data : types) {
                            %>
                            <option value="<%=data%>">
                                <%=data%>
                            </option>
                            <%
                                }
                            %>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td colspan="2">&nbsp;</td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td>
                        <input type="submit" value="Next >" onclick="addToHistory();"/>&nbsp;&nbsp;
                        <input type="button" value="Cancel" onclick="doCancel();"/>
                    </td>
                </tr>
            </table>

    </fieldset>
            </form>
        </div>
    <%
        }
    %>
    <p>&nbsp;</p>
</div>
</body>
</html>