<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.userstore.xsd.StoreData" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
    <script language="javascript" src="../../main/admin/js/main.js"></script>
    <title>WSO2 Carbon - Security Configuration</title></head>

<%
    String haveToDelete = "false";
    Object o = session.getAttribute("userstore-added");
    if (o != null && o.equals("true")) {
        haveToDelete = "true";
        session.removeAttribute("userstore-added");
    }
%>
<script language="JavaScript">

    function setBreadcrumb() {
        var temp = "<%= haveToDelete%>";
        if (temp == "true") {
            goBack(2);
        }
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "User Stores");
    }

    function addToHistory() {
        updateHistory("User Stores", self.location.toString(), "jsp");
    }

    function deleteUserStore(store) {
        var reply = confirm('Do you want to delete the user store ' + store +'?');
        if (reply) {
            addToHistory();
            location.href = 'delete-userstore.jsp?userStore=' + store;
        }
    }
</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>User Store Management</h2>
    <div id="formset">
        <form>
    <fieldset>
        <p>
            <legend>Available User Stores</legend>
        </p>
        <table class="styled">
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Type</th>
                    <th>Description</th>
                    <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <%
                    try {
                        String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
                        UserStoreAdminClient client = new UserStoreAdminClient(cookie);
                        StoreData[] datas = client.getAllUserStoreNames();
                        if (datas != null) {
                            for (StoreData data : datas) {
                                if (data != null) { //Confusing!!. Sometimes a null object comes. Maybe a bug in Axis!!
                %>
                <tr>
                    <td><%=data.getDisplayName()%>
                    </td>
                    <td><%=data.getStoreType()%>
                    </td>
                    <td><%=data.getStoreDescription()%>
                    </td>
                     
                    <td>             
                        <a href="test-userstore.jsp?userStore=<%=data.getDisplayName()%>">
                                <img src="../extensions/core/images/test-connection.gif" alt="Test Connection" title="Test Connection" border="0" /></a>
                            <a href="view-userstore.jsp?userStore=<%=data.getDisplayName()%>" onclick="addToHistory();">
                                <img src="../extensions/core/images/view.gif" alt="View" title="View" border="0" /></a>
                           <%if (!data.getStoreType().equals("default")){ %>
                            <a href="edit-userstore.jsp?userStore=<%=data.getDisplayName()%>" onclick="addToHistory();">
                                <img src="../extensions/core/images/application_edit.gif" alt="Edit" title="Edit" border="0" /></a>
                            <a href="#" onclick="deleteUserStore('<%=data.getDisplayName()%>')" >
                                <img src="../extensions/core/images/cancel.gif" alt="Delete" title="Delete" border="0" /></a>
                           <% } %>
					</td>
                </tr>
                <%
                            }
                        }
                    }
                } catch (Exception e) {
                %>
                <script language="JavaScript" type="text/javascript">
                    wso2.wsf.Util.alertWarning('Error occurred while obtaining user stores. Reason <%=e.getMessage()%>');
                </script>
                <%
                    }
                %>
            </tbody>
        </table>
    </fieldset>
            </form>
    </div>
	<table width="100%" border="0" cellpadding="0" cellspacing="0">
		<tr>
			<td class="addNewSecurity"><a href="add-userstore-step1.jsp" onclick="addToHistory();"><img src="../extensions/core/images/add.gif" border="0" /></a></td>
			<td class="addNewSecurity" width="100%"><a href="add-userstore-step1.jsp" onclick="addToHistory();">Add New User Store</a></td>
		</tr>
	</table>
</div>
</body>
</html>
