<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
"http://www.w3.org/TR/html4/strict.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.client.UserStoreDetails" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="java.util.Map" %>
<%@page import="org.wso2.carbon.security.ui.userstore.xsd.StoreProperty"%>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html>
<head>
    <title>WSO2 Carbon - Security Configuration</title>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js"></script>
</head>

<script language="JavaScript">

    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "View User Store");
    }

</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <div id="breadcrumbDiv" style="display:none;"></div>
    <h2>View User Store</h2>
    <%
        String storeName = request.getParameter("userStore");
        UserStoreDetails data = null;
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            UserStoreAdminClient client = new UserStoreAdminClient(cookie);
            data = client.getUserStoreDetails(storeName);
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (data != null) {
    %>
    <div id="formset">
        <form >
    <fieldset>
        <p>
            <legend>User Store Details</legend>
        </p>
        <table class="styled">
            <thead>
                <tr>
                    <th width="20%"><strong>Information</strong></th>
                    <th>&nbsp;</th>
                </tr>
            </thead>
            <tbody>
            <tr>
                <td><strong>User Store Name</strong></td>
                <td><%=storeName%>
                </td>
            </tr>
            <tr>
                <td><strong>Description</strong></td>
                <td><%=data.getStoreDescription()%>
                </td>
            </tr>
            <tr>
                <td><strong>User Store Type</strong></td>
                <td><%=data.getStoreType()%>
                </td>
            </tr>
            <%
                Map<String, StoreProperty> map = data.getProperties();
                for (Map.Entry<String, StoreProperty> entry : map.entrySet()) {
                    StoreProperty prop = entry.getValue();
                    String value = prop.getValue();
                    if(prop.getInputType().equals("password")){
                        value = "******";
                    }
            %>
            <tr>
                <td><strong><%=prop.getLabelName()%>
                </strong>
                </td>
                <td>
                <%=value%>
                </td>
            </tr>
            <%
                }
            %>
            </tbody>
        </table>
    </fieldset>
            </form>
        </div>
    <%
        }
    %>
</div>
</body>
</html>