<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="java.io.*" %>
<html>
<head>
    <meta http-equiv="content-type" content="text/html;charset=utf-8"/>
    <meta name="generator" content="Adobe GoLive"/>
    <title>Data Services Solution</title>
    <link href="../main/admin/css/common.css" rel="stylesheet" type="text/css" media="all"/>
    <link href="../main/yui/build/container/assets/container.css" rel="stylesheet" type="text/css"
          media="all"/>
    <link href="../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript"
            src="../main/yui/build/yahoo-dom-event/yahoo-dom-event.js"></script>
    <script language="javascript" src="../main/yui/build/dragdrop/dragdrop.js"></script>
    <script language="javascript" src="../main/yui/build/container/container-min.js"></script>
    <script language="javascript" src="global-params.js"></script>
    <script language="javascript" src="../main/admin/js/main.js"></script>
    <script language="javascript" src="../main/admin/js/dhtmlHistory.js"></script>
    <script language="javascript" src="../main/admin/js/WSRequest.js"></script>
    <script language="javascript" src="../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../main/admin/js/cookies.js"></script>
    <script language="javascript" src="extensions/yui/js/yui.js"></script>
    <script language="javascript" src="extensions/core/js/main.js"></script>
    <script language="javascript" src="extensions/core/js/data_service.js"></script>
    <%
        String serviceName = request.getParameter("serviceName");
        String dsConfigContent = request.getParameter("dsConfig");
        String saveConfig = request.getParameter("saveConfig");
        if (saveConfig != null) {
            if (dsConfigContent != null) {
                String filePath = "./repository/dataservices/" + serviceName + ".dbs";
                try {
                    BufferedWriter newContent = new BufferedWriter(new FileWriter(filePath));
                    newContent.write(dsConfigContent);
                    newContent.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
    %>
</head>

<script type="text/javascript">
	var save = <%=request.getParameter("saveConfig")%>;
	if (save) {
		loadServiceListingPage();
	}
</script>

<script type="text/javascript">
    function showBreadcrumbs() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Configure DataService(edit xml)");
    }
</script>

<body onload="showBreadcrumbs();">
<div id="middle">
    <div id="breadcrumbDiv" style="display:inline;"></div>
    <form method="post" action="<%= "./edit_xml.jsp?saveConfig=true&serviceName="+serviceName%>">
        <p>
            <textarea name="dsConfig"
                      style="background-color:lavender; width:99%;height:470px;*height:500px;
                      font-family:verdana;
                      font-size:11px;
                      color: darkblue;
                      border:solid 1px #9fc2d5;
                      overflow-x:auto;
                      overflow-y:auto"><%
                try {
                    if (serviceName != null && serviceName.trim().length() > 0) {
                        String pathToDBS = "./repository/dataservices/" + serviceName + ".dbs";
                        FileReader fr = new FileReader(pathToDBS);
                        BufferedReader bufferReader = new BufferedReader(fr);
                        String line = null;
                        while ((line = bufferReader.readLine()) != null) {%><%=line + "\n"%><%
                        }
                        //do not try to add formatting here. It effects how config is displayed on textarea.
                        bufferReader.close();
                    }
                } catch (Exception e) {
                    System.err.println("File input error");
                }
            %></textarea>
        </p>

        <p>
            <input type="submit" name="save" value="Save"/>
            <input type="reset" name="cancel" value="Cancel" onclick="javascript:loadServiceListingPage();"/>
        </p>
    </form>
</div>
</html>
