<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<%@ page import="org.wso2.carbon.security.ui.client.KeyStoreAdminClient" %>
<%
    if (request.getParameter("addKeystore") != null) {
        String keyStoreName = request.getParameter("keyStoreName");
        try {
            String password = request.getParameter("keyPass");
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            KeyStoreAdminClient client = new KeyStoreAdminClient(cookie);

            
            byte[] content = (byte[])session.getAttribute("org.wso2.carbon.security.content");
            String fileName = (String)session.getAttribute("org.wso2.carbon.security.fileName");
            String ksPassword = (String)session.getAttribute("org.wso2.carbon.security.ksPassword");
            String provider = (String)session.getAttribute("org.wso2.carbon.security.provider");
            String keystoreType = (String)session.getAttribute("org.wso2.carbon.security.keystoreType");
                        
            client.addKeyStore(content, fileName, ksPassword, provider, keystoreType, password);
                        
            response.sendRedirect("keystore-mgt.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                                  "&message=Keystore " +
                                  keyStoreName + " successfully added");

            session.setAttribute("keystore-added", "true");
        } catch (Exception e) {
            response.sendRedirect("add-keystore-step1.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                                  "&errorMessage=Error occurred while adding keystore " +
                                  keyStoreName + ". " + e.getMessage());
        }finally{
            
            session.removeAttribute("org.wso2.carbon.security.content");
            session.removeAttribute("org.wso2.carbon.security.fileName");
            session.removeAttribute("org.wso2.carbon.security.ksPassword");
            session.removeAttribute("org.wso2.carbon.security.provider");
            session.removeAttribute("org.wso2.carbon.security.keystoreType");
        }
    }
%>