<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js" type="text/javascript"></script>
    <script language="javascript" src="../extensions/core/js/vui.js"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/main.js" type="text/javascript"></script>
    <title>WSO2 Carbon - Security Configuration</title>
</head>

<%
    String haveToDelete = "false";
    Object o = session.getAttribute("add-keystore-error");
    if (o != null && o.equals("true")) {
        haveToDelete = "true";
        session.removeAttribute("add-keystore-error");
    }
%>

<script language="JavaScript">


    function doValidation() {
        var reason = "";
        reason = validateEmpty("keystoreFile");
        if (reason != "") {
            wso2.wsf.Util.alertWarning("Enter a keystore file");
            return false;
        }
            
        reason = validateEmpty("ksPassword");
        if (reason != "") {
            wso2.wsf.Util.alertWarning("Enter keystore password");
            return false;
        }
        
    }



    function addToHistory() {
        updateHistory("Add-Step1", self.location.toString(), "jsp");
    }

    function setBreadcrumb() {
        var temp = "<%= haveToDelete%>";
        if (temp == "true") {
            goBack(1);
        }
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Add-Step1");
    }

    function doCancel() {
        goBack(1);
        location.href = 'keystore-mgt.jsp';
    }
</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>

    <div id="breadcrumbDiv" style="display:none;"></div>

    <h2>Add New Keystore</h2>
     <div id="formset">
         <form method="post" name="keysotoreupload" action="add-keystore-step2.jsp"
              enctype="multipart/form-data" onsubmit="return doValidation();">
    <fieldset>
        <p>
        <legend>Step 1: Upload Keystore File</legend>
        </p>

            <table>
                <tr>
                    <td>Keystore File<font color="red">*</font></td>
                    <td>
                        <input name="keystoreFile" id="keystoreFile" size="50" type="file"/>
                    </td>
                </tr>
                <tr>
                    <td>
                        Keystore Password<font color="red">*</font>
                    </td>
                    <td>
                        <input name="ksPassword" type="password" value=""/>
                    </td>
                </tr>
                <tr>
                    <td>Provider</td>
                    <td>
                        <input name="provider" type="text"/>
                    </td>
                </tr>
                <tr>
                    <td>Keystore Type</td>
                    <td>
                        <select name="keystoreType">
                            <option value="jks">JKS</option>
                            <option value="pkcs12">PKCS12</option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td>&nbsp;</td>
                    <td>
                        <input value="Next &gt;" type="submit" onclick="addToHistory();"/>&nbsp;&nbsp;
                        <input value="Cancel" type="button" onclick="doCancel();"/>
                    </td>
                </tr>
            </table>
            <br/>

    </fieldset>
             </form>
         </div>

</div>
</body>
</html>