<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<%@ page import="org.apache.commons.fileupload.disk.DiskFileItem" %>
<%@ page import="org.apache.commons.fileupload.servlet.ServletFileUpload" %>
<%@ page
        import="org.apache.commons.fileupload.servlet.ServletRequestContext" %>
<%@ page import="org.wso2.carbon.security.ui.client.KeyStoreAdminClient" %>
<%@ page
        import="org.wso2.carbon.security.ui.jsp.SecurityUIUtil" %>
<%@ page import="java.util.List" %>

<%
    String keyStore = null;
    try {
        if (ServletFileUpload.isMultipartContent(request)) {
            List items = SecurityUIUtil.parseRequest(new ServletRequestContext(request));
            byte[] content = null;
            String fileName = null;
            for (Object item : items) {
                DiskFileItem diskFileItem = (DiskFileItem) item;
                String name = diskFileItem.getFieldName();
                if (name.equals("certFile")) {
                    content = diskFileItem.get();
                    fileName = diskFileItem.getName();
                } else if (name.equals("keyStore")) {
                    keyStore = new String(diskFileItem.get());
                }
            }

            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            KeyStoreAdminClient client = new KeyStoreAdminClient(cookie);
            client.importCertToStore(fileName, content, keyStore);
            response.sendRedirect("import-cert.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random()) +
                                  "&keyStore=" + keyStore +
                                  "&message=Successfully imported certificate into keystore " +
                                  keyStore);
        }
    } catch (Exception e) {
        e.printStackTrace();
        response.sendRedirect("import-cert.jsp?msgId=MSG" + (System.currentTimeMillis() + Math.random())+
                              "&keyStore=" + keyStore +
                              "&errorMessage=Could not import certificate into keystore. " +
                              e.getMessage());
    }
%>
