<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.KeyStoreAdminClient" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html>
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/main.js"></script>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js" type="text/javascript"></script>
</head>

<script language="JavaScript">

    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Import Certificate");
    }

    function verify() {
        var txtField = document.getElementById("browseField");
        if (txtField.value == "") {
            wso2.wsf.Util.alertWarning('Please specify a path before importing certificate');
        } else {
            document.certForm.submit();                        
        }
    }

</script>

<body onload="setBreadcrumb();">
<div id="middle">
    <jsp:include page="../display-messages.jsp"/>
    <div id="breadcrumbDiv" style="display:none;"></div>

<%
String keyStore = request.getParameter("keyStore");
%>
    <div id="formset">
        <form method="post" name="certForm" enctype="multipart/form-data"
                          action="import-cert-finish.jsp">
<fieldset>
    <legend>Import certificate</legend>
    <table>
        <tbody>
            <tr>
                <td>Certificate <font color="red">*</font> </td>
                <td>

                        <input type="hidden" name="keyStore" id="keyStore"
                               value="<%=keyStore%>"/>
                        <input id="browseField" type="file" name="certFile" size="50"/>
                        <input type="button" value="Import" onclick="verify();"/>

                </td>
            </tr>
        </tbody>
    </table>
</fieldset>
            </form>
        </div>
<p>&nbsp;</p>

<div id="formset">              
    <form>
<fieldset>
    <%
    try {
        String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
        KeyStoreAdminClient client = new KeyStoreAdminClient(cookie);
        String[] aliasSet = client.getStoreEntries(keyStore);
    %>
    <legend>Available Certificates</legend>
    <table class="styled">
        <thead>
            <tr>
                <th>Alias</th>
            </tr>
        </thead>
        <tbody>
            <%
              if (aliasSet != null) {
                  for (String alias : aliasSet) {
            %>
            <tr>
                <td><%=alias%>
                </td>
            </tr>
            <%
                }
            %>
        </tbody>
    </table>
    <%
        }
    } catch (Exception e) {
    %>
    <script language="JavaScript" type="text/javascript">
        wso2.wsf.Util.alertWarning('Cannot list certificates. <%=e.getMessage()%>');
    </script>
    <%
        }
    %>
</fieldset>
        </form>
    </div>
    </div>

</body>
</html>
