<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.security.ui.client.KeyStoreAdminClient" %>
<%@ page import="org.wso2.carbon.security.ui.keystore.xsd.KeyStoreData" %>
<%@ page import="org.wso2.carbon.security.ui.keystore.xsd.CertData" %>
<%@page import="org.wso2.carbon.utils.ServerConstants"%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="../../main/admin/js/breadcrumbs.js" type="text/javascript"></script>
    <script language="javascript" src="../../main/admin/js/cookies.js" type="text/javascript"></script>
    <title>WSO2 Carbon - Security Configuration</title>
</head>

<script language="JavaScript">

    function setBreadcrumb() {
        generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "View Keystore");
    }

</script>

<body onload="setBreadcrumb();">
<div id="middle">
<div id="breadcrumbDiv" style="display:none;"></div>
<div id="formset">
    <form>
<fieldset>
    <legend>Available Certificates</legend>
    <%
        String keyStore = request.getParameter("keyStore");
        try {
            String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
            KeyStoreAdminClient client = new KeyStoreAdminClient(cookie);
            KeyStoreData keyStoreData = client.getKeystoreInfo(keyStore);
            CertData[] certData = keyStoreData.getCerts();

            if (certData != null && certData.length > 0) {
    %>
    <div style="display: inline;" tabindex="-1" id="availableKeyStoreDivId">
                <table class="styled">
                    <thead>
                        <tr>
                            <th>Alias</th>
                            <th>IssuerDN</th>
                            <th>NotAfter</th>
                            <th>NotBefore</th>
                            <th>SerialNumber</th>
                            <th>SubjectDN</th>
                            <th>Version</th>
                        </tr>
                    </thead>
                    <tbody>
                        <%
                            for (CertData cert : certData) {
                                if (cert != null) {
                        %>
                        <tr>
                            <td><%=cert.getAlias()%>
                            </td>
                            <td><%=cert.getIssuerDN()%>
                            </td>
                            <td><%=cert.getNotAfter()%>
                            </td>
                            <td><%=cert.getNotBefore()%>
                            </td>
                            <td><%=cert.getSerialNumber()%>
                            </td>
                            <td><%=cert.getSubjectDN()%>
                            </td>
                            <td><%=cert.getVersion()%>
                            </td>
                        </tr>
                        <%
                                }
                            }
                        %>
                    </tbody>
                </table>
        </div>
    <%
    } else {
    %>
    <i>There are no certificates available</i>
    <br/>
    <%
        }
    %>
</fieldset>
 </form>
</div>
<p>&nbsp;</p>
<%
    if (keyStoreData.getKey() != null) {
%>
<div id="formset">
    <form>
<fieldset>
    <legend>Certificate of the Private Key</legend>
    <table class="styled">
        <thead>
            <tr>
                <th>Alias</th>
                <th>IssuerDN</th>
                <th>NotAfter</th>
                <th>NotBefore</th>
                <th>SerialNumber</th>
                <th>SubjectDN</th>
                <th>Version</th>
            </tr>
        </thead>
        <tbody>
            <%
                CertData cdata = keyStoreData.getKey();
            %>
            <tr>
                <td><%=cdata.getAlias()%>
                </td>
                <td><%=cdata.getIssuerDN()%>
                </td>
                <td><%=cdata.getNotAfter()%>
                </td>
                <td><%=cdata.getNotBefore()%>
                </td>
                <td><%=cdata.getSerialNumber()%>
                </td>
                <td><%=cdata.getSubjectDN()%>
                </td>
                <td><%=cdata.getVersion()%>
                </td>
            </tr>
            <%
                }
            %>
        </tbody>
    </table>
    <%
    } catch (Exception e) {
    %>
    <strong>An error occurred!</strong>

    <p>Error message is : <%=e.getMessage()%>
    </p>
    <%
        }
    %>
</fieldset>
 </form>
</div>
</div>
</body>
</html>