<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%@ page import="org.wso2.carbon.service.mgt.server.*" %> 
<%@ page import="org.wso2.carbon.service.mgt.xsd.ServiceGroupMetaData" %>
<%@ page import="org.wso2.carbon.service.mgt.ui.*" %>

<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.osgi.framework.BundleContext" %>
<%@ page import="org.osgi.framework.ServiceReference" %>
<%@ page import="org.wso2.carbon.service.mgt.admin.ServiceAdminStub" %>
<%@ page import="org.wso2.carbon.service.mgt.xsd.ServiceGroupMetaData" %>
<%@ page import="org.wso2.carbon.service.mgt.xsd.FaultService" %>
<%@ page import="org.wso2.carbon.core.ServerManager" %>
<%@ page import="org.wso2.carbon.registry.service.RegistryService" %>
<%@ page import="org.wso2.registry.Registry"%>
<%@ page import="org.wso2.registry.Resource" %>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <link href="../styles/main.css" rel="stylesheet" type="text/css" media="all"/>
    <script language="javascript" src="global-params.js"></script>
    <script language="javascript" src="../main/admin/js/main.js"></script>
    <script language="javascript" src="../main/admin/js/dhtmlHistory.js"></script>
    <script language="javascript" src="../main/admin/js/WSRequest.js"></script>
    <script language="javascript" src="../main/admin/js/breadcrumbs.js"></script>
    <script language="javascript" src="../main/admin/js/cookies.js"></script>
    <script language="javascript" src="extensions/core/js/services.js"></script>
    <title>WSO2 Carbon - Services</title>


<script language="JavaScript">
        function init() {
            // intialize the code and call to the back end
            wso2.wsf.Util.initURLs();
            /*Initialize the XSLT cache*/
            wso2.wsf.XSLTHelper.init();
            showHomeMenu();                      
            if (isBack(self.location.toString())) {
                var divToLoad = getDivToLoad();
                deleteCurrentEntry();
                setTimeout(divToLoad, 1);
            } else {
                generateBreadcrumbs(document.getElementById("breadcrumbDiv"), "Services");
            }
        }

</script>
</head>

<body onload="init()">

<div id="middle"> 
    <div id="breadcrumbDiv" style="display:inline;"></div>    
    <div id="divListTransports" style="display:none;"></div>
    
      <%
      String cookie = (String)session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
      int noOfServices=0;
      try{
    	  ServiceListing service = new ServiceListing();  
    	  noOfServices =  service.getNoOfFaultyServices(cookie); 
      } catch (Exception e) {
			e.printStackTrace();
		}
	 %>

 	<div id="listServicesInformation">
    <h2>Deployed Services</h2> 
                              <%
		                       ServiceGroupMetaData[] mdata = null;                
		                       try {
		                    	   ServiceListing service = new ServiceListing();   				
		        				mdata = service.getAllServices(cookie);
		        				} catch (Exception e) {
		            				e.printStackTrace();
 		        				}
		        				if (mdata != null) {
		        				%>	
		   	<table class="styled" id="service_groups_info_table">
		                    <thead>
		                        <tr>
									<th>Services</th>
		                            <th>Actions</th>                            
		                            <th>View</th>
		                        </tr>
		                    </thead>
		 					<tbody>
                               
		                         <%    
		                          for (ServiceGroupMetaData datas : mdata )
		                        	{  
		                        	  if(datas != null)
		                        	  {                        		
		                        		
		                         %> 
		                              
		                       <tr>
		                       	 <td><a href="#" onclick="javascript:listServiceData('<%=datas.getServices()[0]%>',true, true); return false;"><%=datas.getServices()[0]%></a></td>  
								 <td>
									<nobr>
                                        &#160;&#160;
                                        &#160;&#160;
									<a href="#" onclick="javascript:deleteServiceGroup('<%=datas.getServices()[0]%>');return false;" id="cancel_link" title="Remove <%=datas.getServices()[0]%> Service Group" alt="Remove">
											&#160;&#160;&#160;&#160;
                                            &#160;&#160;&#160;&#160;
                                            &#160;&#160;&#160;&#160;
									</a>
									 </nobr>
								</td>
							     <td>
                                   <%   
                               			ServerManager serverManager = ServerManager.getInstance();
                                   		BundleContext context = serverManager.getBundleContext();

                                   		ServiceReference reference = context.getServiceReference(RegistryService.class
                                           .getName());
                                   		RegistryService registryService = (RegistryService) context.getService(reference);
                                        Registry systemRegistry = registryService.getSystemRegistry();
                           	            Resource resource = systemRegistry.get("/carbon/connection/props");
                        	            String servicePath = resource.getProperty("service-path");
                        	    		String contextRoot = resource.getProperty("context-root");
                        	    		String host = resource.getProperty("host-name");
                        	   			contextRoot = contextRoot.equals("/") ? "" : contextRoot;
                        	   			host = (host == null) ? "localhost" : host;
                        	    		String httpPort = System.getProperty("carbon.http.port");
                        	    		
                        	    		String URL = "http://" + host + ":" + httpPort + "/" + contextRoot + servicePath +"/"; 
                        	    	%>
		                            <a href="<%=URL%><%=datas.getServices()[0]%>?wsdl&amp;annotation=false" target="_blank">WSDL 1.1 </a>
									<a href="<%=URL%><%=datas.getServices()[0]%>?wsdl2&amp;annotation=false" target="_blank">WSDL 2.0 </a>
									<a href="<%=URL%><%=datas.getServices()[0]%>?xsd&amp;annotation=false" target="_blank">Schema </a>									
								 </td>
		                           <%   
		                               } 
		                        		
		                              }
		                        	 
		        		           %>  
							   </tr>
		 					 </tbody>                     
		  				  </table>
        				
            			 	  
           				<%
						
           					}
							else{
		                %>
						<b>No Active Services</b>
				        <%
		                   	}  		                        	
           				%>   
		</div>
	<div id="divFaultyServices">
     <%
     if(noOfServices != 0)
      { 
      %>
      <br>
      <b><i><a href="faulty_services.jsp">(<%=noOfServices%>) Faulty Service(s)</a></i><b>                
      <%
      }
      %>
	 </div>

<div id="divListServiceData" style="display:none;"></div>    
      
<div id="alertMessageBox" style="display:none;position:absolute;z-index: 600;">
    <!--the message area-->
    <p id="alertMessageBoxMessageArea"></p>
    <!-- the button area-->
    <p id="alertButton" align="right">
        <input id="alertBoxButton" type="button"
               value="  OK  "
               onclick="document.getElementById('alertMessageBox').style.display='none';return false;"/>
    </p>
</div>
</body>
</html>